library(sp)
library(rgdal)
(extSoft <- rgdal_extSoftVersion())
(PROJ6 <- extSoft["proj.4"] > "5")
(PROJ4 <- extSoft["proj.4"] < "5")
bp <- readOGR("b_pump.shp")
prj_file <- strwrap(gsub(",", ", ", readLines("b_pump.prj")))
cat(prj_file, sep="\n")
(input_crs <- proj4string(bp))
input_coord <- coordinates(bp)
print(input_coord, digits=10)
target_coord <- c(-0.13660, 51.51336)
bp_grid <- bp
proj4string(bp_grid)
ll_grid <- try(spTransform(bp_grid, CRS("+init=epsg:4326")))
if (!inherits(ll_grid, "try-error")) {
  ll_grid_coord <- coordinates(ll_grid)
  print(ll_grid_coord, digits=10)
  print(all.equal(target_coord, c(ll_grid_coord), scale=1, check.attributes=FALSE))
} else print(ll_grid)
if (PROJ6) {
  cflags <- system("pkg-config proj --cflags", intern=TRUE)
  libs <- system("pkg-config proj --libs", intern=TRUE)
  system(paste0("g++ -o test test.cpp ", cflags, libs))
  opath <- system("./test", intern=TRUE)
}
if (PROJ6) {
oproj_lib <- Sys.getenv("PROJ_LIB")
Sys.unsetenv("PROJ_LIB")
if (oproj_lib == "") {
  Sys.setenv("PROJ_LIB"=paste0(opath, ":", getwd()))
} else {
  Sys.setenv("PROJ_LIB"=paste0(oproj_lib, ":", getwd()))
}
Sys.getenv("PROJ_LIB")}
fixed <- paste0(proj4string(bp_grid), " +nadgrids=OSTN15_NTv2_OSGBtoETRS.gsb")
if (PROJ6) {
  pI3 <- try(system(paste0("projinfo -s \"", fixed, " +type=crs\" -t EPSG:4326 -o PROJ"), intern=TRUE))
  cat(pI3, sep="\n")
}
Sys.getenv("PROJ_LIB")
file.exists("OSTN15_NTv2_OSGBtoETRS.gsb")
list.files(getwd(), pattern="gsb$")
proj4string(bp_grid)
if (PROJ6) {
  ll_grid <- try(spTransform(bp_grid, CRS("+init=epsg:4326")))
  if (!inherits(ll_grid, "try-error")) {
    ll_grid_coord <- coordinates(ll_grid)
    print(ll_grid_coord, digits=10)
    print(all.equal(target_coord, c(ll_grid_coord), scale=1, check.attributes=FALSE))
  } else print(ll_grid)
}
proj4string(bp_grid) <- CRS("+init=epsg:27700")
proj4string(bp_grid)
if (PROJ6) {
  ll_grid <- try(spTransform(bp_grid, CRS("+init=epsg:4326")))
  if (!inherits(ll_grid, "try-error")) {
    ll_grid_coord <- coordinates(ll_grid)
    print(ll_grid_coord, digits=10)
    print(all.equal(target_coord, c(ll_grid_coord), scale=1, check.attributes=FALSE))
  } else print(ll_grid)
}
proj4string(bp_grid) <- CRS(fixed)
proj4string(bp_grid)
if (PROJ6) {
  ll_grid <- try(spTransform(bp_grid, CRS("+init=epsg:4326")))
  if (!inherits(ll_grid, "try-error")) {
    ll_grid_coord <- coordinates(ll_grid)
    print(ll_grid_coord, digits=10)
    print(all.equal(target_coord, c(ll_grid_coord), scale=1, check.attributes=FALSE))
  } else print(ll_grid)
}
if (PROJ6) {
if (oproj_lib == "") {
  Sys.unsetenv("PROJ_LIB")
} else {
  Sys.setenv("PROJ_LIB"=oproj_lib)
}
}
Sys.getenv("PROJ_LIB")
