library(sf)
(extSoft <- sf_extSoftVersion())
(PROJ6 <- extSoft["proj.4"] > "5")
(PROJ4 <- extSoft["proj.4"] < "5")
bp <- st_read("b_pump.shp")
prj_file <- strwrap(gsub(",", ", ", readLines("b_pump.prj")))
cat(prj_file, sep="\n")
(input_crs <- st_crs(bp))
input_coord <- st_coordinates(st_geometry(bp))
print(input_coord, digits=10)
if (PROJ6){
  try(pI1 <- system(paste0("projinfo --spatial-test intersects -s \"", 
    st_crs(bp)$proj4string, " +type=crs\" -t EPSG:4326 -o PROJ"), intern=TRUE))
  cat(pI1, sep="\n")
}
ll <- st_transform(bp, 4326)
ll_coord <- st_coordinates(st_geometry(ll))
print(ll_coord, digits=10)
target_coord <- c(-0.13660, 51.51336)
all.equal(target_coord, c(ll_coord), scale=1, check.attributes=FALSE)
bp_EPSG <- bp
st_crs(bp_EPSG) <- 27700
(EPSG_crs <- st_crs(bp_EPSG))
if (PROJ6) {
  try(pI2 <- system(paste0("projinfo --spatial-test intersects -s EPSG:",
    st_crs(bp_EPSG)$epsg, "  -t EPSG:4326 -o PROJ"), intern=TRUE))
  cat(pI2, sep="\n")
}
ll_EPSG <- st_transform(bp_EPSG, 4326)
ll_EPSG_coord <- st_coordinates(st_geometry(ll_EPSG))
print(ll_EPSG_coord, digits=10)
all.equal(target_coord, c(ll_EPSG_coord), scale=1, check.attributes=FALSE)
bp_towgs_a <- bp
st_crs(bp_towgs_a) <- paste0(st_crs(bp)$proj4string, " +towgs84=371,-112,434")
(st_crs(bp_towgs_a))
ll_towgs_a <- st_transform(bp_towgs_a, 4326)
ll_towgs_a_coord <- st_coordinates(st_geometry(ll_towgs_a))
print(ll_towgs_a_coord, digits=10)
all.equal(target_coord, c(ll_towgs_a_coord), scale=1, check.attributes=FALSE)
bp_towgs_b <- bp
st_crs(bp_towgs_b) <- paste0(st_crs(bp)$proj4string, " +towgs84=446.448,-125.157,542.06,0.15,0.247,0.842,-20.489")
(st_crs(bp_towgs_b))
ll_towgs_b <- st_transform(bp_towgs_b, 4326)
ll_towgs_b_coord <- st_coordinates(st_geometry(ll_towgs_b))
print(ll_towgs_b_coord, digits=10)
all.equal(target_coord, c(ll_towgs_b_coord), scale=1, check.attributes=FALSE)
if (PROJ6) {
  st_write(bp_towgs_b, "bp_towgs_b.shp", delete_dsn=TRUE)
  prj_file1 <- strwrap(gsub(",", ", ", readLines("bp_towgs_b.prj")))
  cat(prj_file1, sep="\n")
}
if (PROJ6) {
  st_write(bp_towgs_b, "bp_towgs_b.gpkg", delete_dsn=TRUE)
  library(RSQLite)
  db <- dbConnect(SQLite(), dbname="bp_towgs_b.gpkg")
  cat(strwrap(gsub(",", ", ", dbReadTable(db, "gpkg_spatial_ref_sys")$definition[4])), sep="\n")
  dbDisconnect(db)
}




