library(sp)
set_ReplCRS_warn(FALSE)
library(rgdal)
(extSoft <- rgdal_extSoftVersion())
(PROJ6 <- extSoft["PROJ.4"] > "5")
(PROJ4 <- extSoft["PROJ.4"] < "5")
bp <- readOGR("b_pump.shp")
prj_file <- strwrap(gsub(",", ", ", readLines("b_pump.prj")))
cat(prj_file, sep="\n")
(input_crs <- proj4string(bp))
input_coord <- coordinates(bp)
print(input_coord, digits=10)
if (PROJ6){
  try(pI1 <- system(paste0("projinfo --spatial-test intersects -s \"", 
    proj4string(bp), " +type=crs\" -t EPSG:4326 -o PROJ"), intern=TRUE))
  cat(pI1, sep="\n")
}
ll <- spTransform(bp, CRS("+init=epsg:4326"))
ll_coord <- coordinates(ll)
print(ll_coord, digits=10)
target_coord <- c(-0.13660, 51.51336)
all.equal(target_coord, c(ll_coord), scale=1, check.attributes=FALSE)
bp_EPSG <- bp
proj4string(bp_EPSG) <- CRS("+init=epsg:27700")
(EPSG_crs <- proj4string(bp_EPSG))
if (PROJ6) {
  try(pI2 <- system(paste0("projinfo --spatial-test intersects -s EPSG:",
    "27700", "  -t EPSG:4326 -o PROJ"), intern=TRUE))
  cat(pI2, sep="\n")
}
ll_EPSG <- spTransform(bp_EPSG, CRS("+init=epsg:4326"))
ll_EPSG_coord <- coordinates(ll_EPSG)
print(ll_EPSG_coord, digits=10)
all.equal(target_coord, c(ll_EPSG_coord), scale=1, check.attributes=FALSE)
bp_towgs_a <- bp
proj4string(bp_towgs_a) <- CRS(paste0(proj4string(bp), " +towgs84=371,-112,434"))
(proj4string(bp_towgs_a))
ll_towgs_a <- spTransform(bp_towgs_a, CRS("+init=epsg:4326"))
ll_towgs_a_coord <- coordinates(ll_towgs_a)
print(ll_towgs_a_coord, digits=10)
all.equal(target_coord, c(ll_towgs_a_coord), scale=1, check.attributes=FALSE)
bp_towgs_b <- bp
proj4string(bp_towgs_b) <- CRS(paste0(proj4string(bp), " +towgs84=446.448,-125.157,542.06,0.15,0.247,0.842,-20.489"))
(proj4string(bp_towgs_b))
ll_towgs_b <- spTransform(bp_towgs_b, CRS("+init=epsg:4326"))
ll_towgs_b_coord <- coordinates(ll_towgs_b)
print(ll_towgs_b_coord, digits=10)
all.equal(target_coord, c(ll_towgs_b_coord), scale=1, check.attributes=FALSE)
if (PROJ6) {
  writeOGR(bp_towgs_b, dsn=".", layer="bp_towgs_b", driver="ESRI Shapefile", overwrite_layer=TRUE)
  prj_file1 <- strwrap(gsub(",", ", ", readLines("bp_towgs_b.prj")))
  cat(prj_file1, sep="\n")
}
if (PROJ6) {
  writeOGR(bp_towgs_b, dsn="bp_towgs_b.gpkg", layer="bp_towgs_b", driver="GPKG", overwrite_layer=TRUE)
  library(RSQLite)
  db <- dbConnect(SQLite(), dbname="bp_towgs_b.gpkg")
  cat(strwrap(gsub(",", ", ", dbReadTable(db, "gpkg_spatial_ref_sys")$definition[4])), sep="\n")
  dbDisconnect(db)
}




